#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";
#endif
#define YYBYACC 1

#include	"oops.h"
#include	"modules.h"

extern	FILE	*yyin;

int	atline;
char	*conf_file_name;
int	parser_errors;

static	char	*storage_path = NULL;
static	off_t	storage_size = 0;
static	off_t	storage_offset = 0;
static	int	ns_curr;

static	struct	peer_c	*peerc_ptr = NULL;
static	struct	range	badports[MAXBADPORTS];
static	struct	range	*badp_p = NULL;
struct	peer_c {
	char			type;
	struct	acls		*acls;
	char			*my_auth;
	acl_chk_list_hdr_t	*peer_access;
	int			down_timeout;
} peer_c = {PEER_SIBLING,NULL,NULL,NULL, 60};

static	void			add_to_stop_cache(char *);
static	struct	domain_list	*load_domlist_from_file(char *);
static	struct	domain_list	*load_domlist_from_list(struct string_list *);
static	int			string_to_days(struct denytime *, struct string_list *);

typedef union	{
	int				INT;
	char				*STRPTR;
	char				CHAR;
	struct	cidr_net		*NETPTR;
	struct	group_ops_struct	*GROUPOPS;
	struct	acl			*ACL;
	struct	domain_list		*DOMAIN;
	struct	storage_st		*STORAGEST;
	struct	string_list		*STRING_LIST;
	off_t				OFFSET;
	} YYSTYPE;
#define LOGFILE 257
#define ACCESSLOG 258
#define STATISTICS 259
#define PIDFILE 260
#define NAMESERVER 261
#define HTTP_PORT 262
#define ICP_PORT 263
#define ICONS_HOST 264
#define ICONS_PORT 265
#define ICONS_PATH 266
#define EXPIRE_VALUE 267
#define FTP_EXPIRE_VALUE_T 268
#define EXPIRE_INTERVAL 269
#define STOP_CACHE 270
#define MAXRESIDENT 271
#define MINRESIDENT 272
#define CONNECT_FROM 273
#define MEM_MAX 274
#define LO_MARK 275
#define HI_MARK 276
#define DISK_LOW_FREE_T 277
#define DISK_HI_FREE_T 278
#define PARENT_T 279
#define PEER_T 280
#define SIBLING_T 281
#define LOCAL_DOMAIN_T 282
#define LOCAL_NETWORKS_T 283
#define GROUP 284
#define NETWORK 285
#define NETWORKS 286
#define HTTP 287
#define ICP 288
#define NUMBER 289
#define NUMBER_K 290
#define NUMBER_M 291
#define STRING 292
#define ALLOW 293
#define DENY 294
#define BADPORTS_T 295
#define MISS_T 296
#define AUTH_MODS_T 297
#define REDIR_MODS_T 298
#define DSTDOMAIN 299
#define DB_CACHE_MEM 300
#define STORAGE 301
#define SIZE 302
#define PATH 303
#define DBNAME 304
#define DBHOME 305
#define PEER_PARENT_T 306
#define PEER_SIBLING_T 307
#define BANDWIDTH_T 308
#define DENYTIME_T 309
#define L_EOS 310
#define ICP_TIMEOUT 311
#define MODULE 312
#define INCLUDE_T 313
#define ALWAYS_CHECK_FRESHNESS_T 314
#define FORCE_HTTP11_T 315
#define FORCE_COMPLETION_T 316
#define LAST_MODIFIED_FACTOR_T 317
#define MAX_EXPIRE_VALUE_T 318
#define INSERT_X_FORWARDED_FOR_T 319
#define INSERT_VIA_T 320
#define ACL_T 321
#define REFRESH_PATTERN_T 322
#define ACL_ALLOW_T 323
#define ACL_DENY_T 324
#define SRCDOMAINS_T 325
#define BIND_T 326
#define STOP_CACHE_ACL_T 327
#define NETWORKS_ACL_T 328
#define STORAGE_OFFSET_T 329
#define AUTO_T 330
#define USERID_T 331
#define CHROOT_T 332
#define BIND_ACL_T 333
#define MAXREQRATE_T 334
#define BLACKLIST_T 335
#define START_RED_T 336
#define REFUSE_AT_T 337
#define DONT_CACHE_WITHOUT_LAST_MODIFIED_T 338
#define MY_AUTH_T 339
#define PARENT_AUTH_T 340
#define PEER_ACCESS_T 341
#define PER_SESS_BW_T 342
#define PER_IP_BW_T 343
#define PER_IP_CONN_T 344
#define CONN_FROM_T 345
#define ALWAYS_CHECK_FRESHNESS_ACL_T 346
#define PEER_DOWN_TIMEOUT_T 347
#define EXPIRE_TIME_T 348
#define SWAP_ADVANCE_T 349
#define FETCH_WITH_CLIENT_SPEED_T 350
#define FTP_PASSW_T 351
#define NEGATIVE_CACHE_T 352
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    0,   35,   35,   34,   34,   34,   34,   34,
   34,   34,   34,   34,   34,   34,   34,   34,   34,   34,
   34,   34,   34,   34,   34,   34,   34,   34,   34,   34,
   34,   34,   34,   34,   34,   34,   34,   34,   34,   34,
   34,   34,   34,   34,   34,   34,   34,   34,   34,   34,
   34,   34,   34,   34,   34,   34,   34,   34,   34,   34,
   34,   34,   34,   34,   34,   34,   34,   36,   36,   36,
   36,   87,   88,   89,   91,   93,   92,   95,   76,   94,
   77,   37,   37,   37,   37,   83,   90,   84,   85,   86,
   82,   38,   39,   40,   42,   65,   66,   67,   41,   43,
   44,   45,   69,   46,   48,   47,   55,   56,   57,   58,
   54,   49,   53,   50,   51,   52,   59,   60,   61,   62,
   63,   64,   78,   79,   80,   68,   70,   72,   71,   26,
   27,    4,   81,   81,    7,    7,    6,    5,   75,   96,
   96,   96,   96,   96,   96,   96,   97,   97,   74,   25,
   25,   24,   24,   24,   24,   73,    3,   11,   11,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   19,   16,   16,   17,
   18,   15,   20,   21,   22,   23,   98,   98,   98,   99,
   99,   14,   13,   13,   13,   13,   12,   12,   12,   12,
   31,   31,   29,   30,   30,   28,    8,    8,    8,    9,
   33,   33,   32,    1,    1,    2,
};
short yylen[] = {                                         2,
    0,    1,    2,    1,    2,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    2,    1,    3,    4,    7,
    8,    3,    3,    3,    3,    3,    3,    2,    3,    3,
    3,    3,    4,    7,    8,    6,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    2,    3,    2,    3,
    3,    3,    2,    3,    3,    3,    3,    3,    4,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    1,
    1,    1,    6,    5,    1,    2,    1,    1,    5,    2,
    2,    3,    3,    3,    1,    1,    1,    2,    8,    1,
    2,    3,    3,    3,    3,    6,    1,    1,    2,    3,
    5,    3,    3,    3,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    2,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    5,    1,    3,    1,
    3,    3,    5,    5,    4,    4,    5,    5,    4,    4,
    1,    2,    4,    1,    2,    4,    1,    2,    3,    1,
    1,    2,    1,    1,    2,    1,
};
short yydefred[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   67,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    6,    7,    8,    9,   10,
   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,
   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,
   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,
   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,
   61,   62,   63,   64,   65,   66,  132,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  130,    0,    0,    0,    0,    0,
    0,    0,  213,    0,    0,  216,    0,    0,  157,    0,
    0,    0,    0,    0,    0,  138,    0,  107,  109,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   78,    0,    0,  210,
  113,    0,    0,    0,    0,    0,    0,   68,    0,    0,
   82,    0,    0,   92,   93,   94,  100,  101,  104,  105,
  106,  112,  115,  116,   96,   97,   98,   95,  126,  127,
  129,  117,  118,    0,    0,  212,  121,  122,  215,    0,
  125,    0,    0,    0,    0,    0,  124,  123,  102,    0,
  110,  111,  114,   79,   81,   91,    0,   88,   89,   99,
   90,   72,   74,   87,   75,   77,   76,  120,  108,    0,
  208,  128,   80,   73,  103,    0,   69,    0,   83,  119,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  171,
  172,  170,  165,  173,  175,  176,  174,  166,  167,  168,
  169,  131,    0,    0,    0,    0,  151,    0,    0,  137,
  135,    0,    0,  209,    0,    0,    0,    0,    0,    0,
  188,    0,    0,    0,    0,    0,    0,    0,    0,  177,
    0,    0,    0,    0,    0,    0,    0,    0,  159,    0,
  153,  152,  155,  154,  139,  134,    0,  136,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  145,  146,
  147,    0,  160,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  192,  179,  178,  180,  181,  182,    0,  162,
  163,  164,  183,  184,  185,  186,  156,  133,   86,   70,
    0,   84,    0,    0,    0,  140,  141,    0,    0,    0,
    0,  148,  205,  202,  199,    0,  200,    0,  195,    0,
  196,    0,  189,    0,  191,    0,   71,   85,    0,    0,
  143,  144,  142,  149,  198,  197,  194,  193,    0,  161,
  206,  203,  187,
};
short yydgoto[] = {                                      63,
  157,  158,  160,  190,  167,  311,  312,  191,  192,  288,
  289,  290,  291,  292,  293,  294,  295,  296,  297,  298,
  299,  300,  301,  235,  236,  146,  304,  364,  365,  366,
  367,  154,  155,   64,   65,   66,   67,   68,   69,   70,
   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,
   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,
  101,  102,  103,  104,  105,  106,  107,  108,  109,  110,
  111,  112,  113,  114,  115,  116,  117,  118,  119,  120,
  121,  122,  123,  124,  125,  361,  362,  323,  324,
};
short yysindex[] = {                                    400,
 -282, -257, -257, -256, -250, -244, -236, -214, -215, -205,
 -203, -197, -195, -190, -191, -186, -182, -184, -179, -179,
 -179, -178, -177, -257, -257, -174, -183, -173, -179,  -10,
 -172, -171,    0, -167, -169, -185, -181, -165, -163, -162,
 -257, -257, -157, -257, -156, -155, -257, -154, -257, -257,
 -153, -179, -179, -179, -180, -257, -151, -257, -179, -257,
 -257, -147,    0,    0,  400,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, -112, -111, -166,
 -164, -161, -160, -159, -158, -152, -150, -149, -148, -146,
 -145, -143, -140, -139,    0, -136, -135, -134, -133, -132,
 -179, -179,    0, -174, -117,    0, -116, -183,    0,   20,
 -115, -224, -114, -113, -108,    0,   22,    0,    0, -101,
  -99,  -98,  -97,  -96,  -95, -179,  -94,  -93,  -91,  -89,
  -88,  -87,  -86,  -83,  -82,  -81,    0,  -80,  -79,    0,
    0,  -34,  -78,  -77,  -75,  -74,    0,    0, -179,  -73,
    0, -179,  -72,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  -71, -179,    0,    0,    0,    0, -228,
    0, -258, -138, -142, -224,   23,    0,    0,    0, -109,
    0,    0,    0,    0,    0,    0, -257,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -257,
    0,    0,    0,    0,    0, -179,    0, -179,    0,    0,
   30, -183,   32,   34,  -85, -237, -257, -257, -179, -257,
 -268, -257, -179, -179, -179, -179, -257, -228,   38,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  100,  107,  110,  141,    0,  -70,  -69,    0,
    0, -100, -179,    0,   76,   78, -243,  151, -206, -206,
    0, -249,  181,  183,  184,  185,  188,  190,  191,    0,
 -257,  192,  196,  197,  198,  201,  202,  203,    0,  -43,
    0,    0,    0,    0,    0,    0,  -42,    0,  -41, -272,
 -266,  -29,  -28,  213,  214, -257,  -18, -179,    0,    0,
    0, -121,    0,  -17,  -19, -110, -104, -107, -103,  186,
  219,  -85,    0,    0,    0,    0,    0,    0,  221,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  -32,    0,  -27, -257, -257,    0,    0,  222,  223,  225,
  -25,    0,    0,    0,    0,  161,    0,  162,    0,  163,
    0,  164,    0, -179,    0,  -16,    0,    0,  231,  232,
    0,    0,    0,    0,    0,    0,    0,    0,  204,    0,
    0,    0,    0,
};
short yyrindex[] = {                                    295,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  206,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  -57,    0,    0,    0,  -56,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  109,    0,    0,    0,    0,  303,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  171,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  173,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  240,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -106, -102,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,
};
short yygindex[] = {                                      0,
 -144,    0,    0,    5,    0,  -12,    0, -187,    0,    0,
   13,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   69,  -20,   71, -300, -276, -293,
 -283,    0, -141,  241,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  -55,    0,    0,  -64,
};
#define YYTABLESIZE 752
short yytable[] = {                                     147,
  148,  211,  214,  401,  261,  322,  128,  129,  161,  260,
  199,  202,  226,  229,  405,  309,  359,  409,  204,  127,
  407,  411,  201,  153,  347,  127,  368,  126,  151,  152,
  302,  184,  185,  186,  127,  130,  369,  390,  193,  145,
  360,  131,  127,  392,  331,  173,  174,  132,  176,  352,
  353,  179,  133,  181,  182,  325,  326,  272,  273,  274,
  188,  359,  354,  355,  194,  195,  275,  276,  277,  278,
  403,  303,  314,  408,  134,  412,  135,  232,  233,  279,
  280,  404,  406,  136,  410,  360,  352,  353,  137,  327,
  328,  138,  330,  139,  333,  356,  281,  357,  140,  282,
  141,  156,  142,  358,  234,  283,  143,  144,  207,  145,
  149,  150,  162,  284,  285,  286,  287,  153,  159,  163,
  164,  165,  166,  170,  168,  171,  172,  318,  169,  187,
  224,  225,  200,  203,  175,  177,  178,  180,  183,  332,
  189,  196,  230,  204,  240,  205,  302,  308,  206,  207,
  208,  209,  317,  305,  319,  247,  320,  210,  341,  211,
  212,  213,  340,  214,  215,  342,  216,  207,  343,  217,
  218,  352,  353,  219,  220,  221,  222,  223,  266,  127,
  127,  268,  127,  353,  354,  355,  353,  204,  352,  352,
  201,  127,  227,  228,  231,  237,  238,  198,  201,  344,
  350,  239,  351,  321,  271,    2,  419,  420,  241,  363,
  242,  243,  244,  245,  246,  248,  249,  356,  250,  357,
  251,  252,  253,  254,  372,  358,  255,  256,  257,  258,
  259,  262,  263,  207,  264,  265,  267,  269,  270,  345,
  346,  373,  374,  375,  310,  315,  376,  316,  377,  378,
  380,  313,  211,  214,  381,  382,  383,  127,  329,  384,
  385,  386,  334,  335,  336,  337,  387,  388,  389,  394,
  395,  396,  397,  399,  353,  352,  414,  417,  413,  416,
  421,  422,  418,  423,  424,  425,  426,  427,  428,  431,
  432,  338,  349,  430,    1,  150,  433,  158,  190,  348,
  339,  371,    3,  307,  306,  197,  402,  415,    0,    0,
    0,    0,    0,    0,    0,    0,  310,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  370,    0,    0,    0,
    0,    0,    0,    0,    0,  379,    0,  400,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  391,  393,    0,    0,    0,    0,
  398,    0,    0,    0,  207,  207,  207,  207,  207,  207,
  207,  207,  207,  207,  207,  207,  207,  207,  207,  207,
  207,  207,  207,  207,  207,  207,  207,  207,  207,    0,
  207,  207,  207,  429,  207,  207,  207,    0,    0,    0,
    0,    0,    0,  207,  207,  207,  207,    0,  207,  207,
    0,    0,  207,  207,    0,    0,  207,  207,  207,  207,
  207,    0,  207,  207,  207,  207,  207,  207,  207,  207,
  207,  207,  207,  207,  207,  207,  207,    0,    0,  207,
  207,  207,  207,  207,  207,  207,  207,    0,  207,    0,
  207,  207,  207,  207,  207,    0,  207,  207,  207,  207,
  207,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    0,    4,    4,    4,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    4,    4,    0,    0,    4,
    4,    0,    0,    0,    0,    4,    4,    4,    0,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    0,    4,    4,    0,    0,    0,    4,    4,    4,    0,
    4,    4,    4,    4,    0,    4,    0,    0,    0,    0,
    0,    4,    0,    4,    4,    4,    4,    4,    5,    5,
    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
    5,    5,    5,    0,    5,    5,    5,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    5,    5,    0,    0,    5,    5,    0,    0,
    0,    0,    5,    5,    5,    0,    5,    5,    5,    5,
    5,    5,    5,    5,    5,    5,    5,    0,    5,    5,
    0,    0,    0,    5,    5,    5,    0,    5,    5,    5,
    5,    0,    5,    0,    0,    0,    0,    0,    5,    0,
    5,    5,    5,    5,    5,    1,    2,    3,    4,    5,
    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,
   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,
    0,   26,   27,   28,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   29,
   30,    0,    0,   31,   32,    0,    0,    0,    0,   33,
   34,   35,    0,   36,   37,   38,   39,   40,   41,   42,
   43,   44,   45,   46,    0,   47,   48,    0,    0,    0,
   49,   50,   51,    0,   52,   53,   54,   55,    0,   56,
    0,    0,    0,    0,    0,   57,    0,   58,   59,   60,
   61,   62,
};
short yycheck[] = {                                      20,
   21,   59,   59,  125,  192,   91,    2,    3,   29,   44,
  123,  123,  154,  158,  125,  125,  317,  125,  125,  292,
  125,  125,  125,  292,  125,  292,  320,  310,   24,   25,
  289,   52,   53,   54,  292,  292,  320,  310,   59,  289,
  317,  292,  292,  310,  313,   41,   42,  292,   44,  293,
  294,   47,  289,   49,   50,  293,  294,  286,  287,  288,
   56,  362,  306,  307,   60,   61,  295,  296,  297,  298,
  364,  330,  260,  367,  289,  369,  292,  302,  303,  308,
  309,  365,  366,  289,  368,  362,  293,  294,  292,  277,
  278,  289,  280,  289,  282,  339,  325,  341,  289,  328,
  292,  285,  289,  347,  329,  334,  289,  292,    0,  289,
  289,  289,  123,  342,  343,  344,  345,  292,  292,  292,
  292,  289,  292,  289,  310,  289,  289,  272,  310,  310,
  151,  152,  128,  129,  292,  292,  292,  292,  292,  281,
  292,  289,  123,  310,  123,  310,  289,  125,  310,  310,
  310,  310,  123,  292,  123,  176,  123,  310,   59,  310,
  310,  310,  125,  310,  310,   59,  310,   59,   59,  310,
  310,  293,  294,  310,  310,  310,  310,  310,  199,  292,
  292,  202,  292,  294,  306,  307,  294,  294,  293,  293,
  293,  292,  310,  310,  310,  310,  310,  310,  310,   59,
  125,  310,  125,  289,  225,    0,  394,  395,  310,   59,
  310,  310,  310,  310,  310,  310,  310,  339,  310,  341,
  310,  310,  310,  310,   44,  347,  310,  310,  310,  310,
  310,  310,  310,  125,  310,  310,  310,  310,  310,  310,
  310,   59,   59,   59,  240,  266,   59,  268,   59,   59,
   59,  247,  310,  310,   59,   59,   59,  292,  279,   59,
   59,   59,  283,  284,  285,  286,  310,  310,  310,  299,
  299,   59,   59,  292,  294,  293,   58,  310,   93,   59,
   59,   59,  310,   59,  310,  125,  125,  125,  125,   59,
   59,  287,  313,  310,    0,  125,   93,  125,   59,  312,
  288,  322,    0,  235,  234,   65,  362,  372,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  312,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  322,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  331,   -1,  358,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  350,  351,   -1,   -1,   -1,   -1,
  356,   -1,   -1,   -1,  256,  257,  258,  259,  260,  261,
  262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,   -1,
  282,  283,  284,  414,  286,  287,  288,   -1,   -1,   -1,
   -1,   -1,   -1,  295,  296,  297,  298,   -1,  300,  301,
   -1,   -1,  304,  305,   -1,   -1,  308,  309,  310,  311,
  312,   -1,  314,  315,  316,  317,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,   -1,   -1,  331,
  332,  333,  334,  335,  336,  337,  338,   -1,  340,   -1,
  342,  343,  344,  345,  346,   -1,  348,  349,  350,  351,
  352,  256,  257,  258,  259,  260,  261,  262,  263,  264,
  265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,   -1,  282,  283,  284,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  300,  301,   -1,   -1,  304,
  305,   -1,   -1,   -1,   -1,  310,  311,  312,   -1,  314,
  315,  316,  317,  318,  319,  320,  321,  322,  323,  324,
   -1,  326,  327,   -1,   -1,   -1,  331,  332,  333,   -1,
  335,  336,  337,  338,   -1,  340,   -1,   -1,   -1,   -1,
   -1,  346,   -1,  348,  349,  350,  351,  352,  256,  257,
  258,  259,  260,  261,  262,  263,  264,  265,  266,  267,
  268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,   -1,  282,  283,  284,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  300,  301,   -1,   -1,  304,  305,   -1,   -1,
   -1,   -1,  310,  311,  312,   -1,  314,  315,  316,  317,
  318,  319,  320,  321,  322,  323,  324,   -1,  326,  327,
   -1,   -1,   -1,  331,  332,  333,   -1,  335,  336,  337,
  338,   -1,  340,   -1,   -1,   -1,   -1,   -1,  346,   -1,
  348,  349,  350,  351,  352,  256,  257,  258,  259,  260,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
   -1,  282,  283,  284,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  300,
  301,   -1,   -1,  304,  305,   -1,   -1,   -1,   -1,  310,
  311,  312,   -1,  314,  315,  316,  317,  318,  319,  320,
  321,  322,  323,  324,   -1,  326,  327,   -1,   -1,   -1,
  331,  332,  333,   -1,  335,  336,  337,  338,   -1,  340,
   -1,   -1,   -1,   -1,   -1,  346,   -1,  348,  349,  350,
  351,  352,
};
#define YYFINAL 63
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 352
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,"','",0,0,0,0,0,0,0,0,0,0,0,0,0,"':'","';'",0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'['",0,"']'",0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"LOGFILE","ACCESSLOG","STATISTICS","PIDFILE","NAMESERVER","HTTP_PORT",
"ICP_PORT","ICONS_HOST","ICONS_PORT","ICONS_PATH","EXPIRE_VALUE",
"FTP_EXPIRE_VALUE_T","EXPIRE_INTERVAL","STOP_CACHE","MAXRESIDENT","MINRESIDENT",
"CONNECT_FROM","MEM_MAX","LO_MARK","HI_MARK","DISK_LOW_FREE_T","DISK_HI_FREE_T",
"PARENT_T","PEER_T","SIBLING_T","LOCAL_DOMAIN_T","LOCAL_NETWORKS_T","GROUP",
"NETWORK","NETWORKS","HTTP","ICP","NUMBER","NUMBER_K","NUMBER_M","STRING",
"ALLOW","DENY","BADPORTS_T","MISS_T","AUTH_MODS_T","REDIR_MODS_T","DSTDOMAIN",
"DB_CACHE_MEM","STORAGE","SIZE","PATH","DBNAME","DBHOME","PEER_PARENT_T",
"PEER_SIBLING_T","BANDWIDTH_T","DENYTIME_T","L_EOS","ICP_TIMEOUT","MODULE",
"INCLUDE_T","ALWAYS_CHECK_FRESHNESS_T","FORCE_HTTP11_T","FORCE_COMPLETION_T",
"LAST_MODIFIED_FACTOR_T","MAX_EXPIRE_VALUE_T","INSERT_X_FORWARDED_FOR_T",
"INSERT_VIA_T","ACL_T","REFRESH_PATTERN_T","ACL_ALLOW_T","ACL_DENY_T",
"SRCDOMAINS_T","BIND_T","STOP_CACHE_ACL_T","NETWORKS_ACL_T","STORAGE_OFFSET_T",
"AUTO_T","USERID_T","CHROOT_T","BIND_ACL_T","MAXREQRATE_T","BLACKLIST_T",
"START_RED_T","REFUSE_AT_T","DONT_CACHE_WITHOUT_LAST_MODIFIED_T","MY_AUTH_T",
"PARENT_AUTH_T","PEER_ACCESS_T","PER_SESS_BW_T","PER_IP_BW_T","PER_IP_CONN_T",
"CONN_FROM_T","ALWAYS_CHECK_FRESHNESS_ACL_T","PEER_DOWN_TIMEOUT_T",
"EXPIRE_TIME_T","SWAP_ADVANCE_T","FETCH_WITH_CLIENT_SPEED_T","FTP_PASSW_T",
"NEGATIVE_CACHE_T",
};
char *yyrule[] = {
"$accept : config",
"config :",
"config : statement",
"config : statements statement",
"statements : statement",
"statements : statements statement",
"statement : logfile",
"statement : accesslog",
"statement : statistics",
"statement : pidfile",
"statement : nameserver",
"statement : bind",
"statement : connect_from",
"statement : http_port",
"statement : icp_port",
"statement : icp_timeout",
"statement : icons_host",
"statement : icons_path",
"statement : icons_port",
"statement : expire_value",
"statement : max_expire_value",
"statement : ftp_expire_value",
"statement : expire_interval",
"statement : expiretime",
"statement : last_modified_factor",
"statement : always_check_freshness",
"statement : always_check_freshness_acl",
"statement : force_http11",
"statement : force_completion",
"statement : disk_low_free",
"statement : disk_hi_free",
"statement : parent",
"statement : parent_auth",
"statement : local_domain",
"statement : local_networks",
"statement : stop_cache",
"statement : maxresident",
"statement : minresident",
"statement : mem_max",
"statement : negative_cache",
"statement : lo_mark",
"statement : hi_mark",
"statement : swap_advance",
"statement : group",
"statement : peer",
"statement : storage",
"statement : insert_x_forwarded_for",
"statement : insert_via",
"statement : dbhome",
"statement : dbname",
"statement : db_cache_mem",
"statement : module",
"statement : acl",
"statement : refresh_pattern",
"statement : acl_allow",
"statement : acl_deny",
"statement : stop_cache_acl",
"statement : userid",
"statement : anon_ftp_passw",
"statement : chroot",
"statement : bind_acl",
"statement : blacklist",
"statement : start_red",
"statement : refuse_at",
"statement : fetch_with_client_speed",
"statement : dont_cache_without_last_modified",
"statement : error L_EOS",
"statement : L_EOS",
"logfile : LOGFILE string L_EOS",
"logfile : LOGFILE string string L_EOS",
"logfile : LOGFILE string '{' num num '}' L_EOS",
"logfile : LOGFILE string '{' num num '}' string L_EOS",
"userid : USERID_T string L_EOS",
"anon_ftp_passw : FTP_PASSW_T string L_EOS",
"chroot : CHROOT_T string L_EOS",
"blacklist : BLACKLIST_T num L_EOS",
"refuse_at : REFUSE_AT_T num L_EOS",
"start_red : START_RED_T num L_EOS",
"dont_cache_without_last_modified : DONT_CACHE_WITHOUT_LAST_MODIFIED_T L_EOS",
"insert_x_forwarded_for : INSERT_X_FORWARDED_FOR_T string L_EOS",
"fetch_with_client_speed : FETCH_WITH_CLIENT_SPEED_T string L_EOS",
"insert_via : INSERT_VIA_T string L_EOS",
"accesslog : ACCESSLOG string L_EOS",
"accesslog : ACCESSLOG string string L_EOS",
"accesslog : ACCESSLOG string '{' num num '}' L_EOS",
"accesslog : ACCESSLOG string '{' num num '}' string L_EOS",
"refresh_pattern : REFRESH_PATTERN_T string num string num L_EOS",
"bind_acl : BIND_ACL_T STRING L_EOS",
"acl_allow : ACL_ALLOW_T STRING L_EOS",
"acl_deny : ACL_DENY_T STRING L_EOS",
"stop_cache_acl : STOP_CACHE_ACL_T STRING L_EOS",
"acl : ACL_T STRING L_EOS",
"statistics : STATISTICS STRING L_EOS",
"pidfile : PIDFILE STRING L_EOS",
"nameserver : NAMESERVER STRING L_EOS",
"connect_from : CONNECT_FROM STRING L_EOS",
"stop_cache : STOP_CACHE STRING L_EOS",
"maxresident : MAXRESIDENT NUMBER L_EOS",
"minresident : MINRESIDENT NUMBER L_EOS",
"bind : BIND_T string L_EOS",
"http_port : HTTP_PORT NUMBER L_EOS",
"icp_port : ICP_PORT NUMBER L_EOS",
"icp_timeout : ICP_TIMEOUT NUMBER L_EOS",
"negative_cache : NEGATIVE_CACHE_T NUMBER L_EOS",
"icons_host : ICONS_HOST STRING L_EOS",
"icons_port : ICONS_PORT NUMBER L_EOS",
"icons_path : ICONS_PATH STRING L_EOS",
"always_check_freshness : ALWAYS_CHECK_FRESHNESS_T L_EOS",
"always_check_freshness_acl : ALWAYS_CHECK_FRESHNESS_ACL_T STRING L_EOS",
"force_http11 : FORCE_HTTP11_T L_EOS",
"force_completion : FORCE_COMPLETION_T NUMBER L_EOS",
"last_modified_factor : LAST_MODIFIED_FACTOR_T NUMBER L_EOS",
"expire_value : EXPIRE_VALUE NUMBER L_EOS",
"expiretime : EXPIRE_TIME_T string_list",
"max_expire_value : MAX_EXPIRE_VALUE_T NUMBER L_EOS",
"ftp_expire_value : FTP_EXPIRE_VALUE_T NUMBER L_EOS",
"expire_interval : EXPIRE_INTERVAL NUMBER L_EOS",
"disk_low_free : DISK_LOW_FREE_T NUMBER L_EOS",
"disk_hi_free : DISK_HI_FREE_T NUMBER L_EOS",
"parent : PARENT_T string num L_EOS",
"parent_auth : PARENT_AUTH_T string L_EOS",
"local_domain : LOCAL_DOMAIN_T domainlist L_EOS",
"local_networks : LOCAL_NETWORKS_T network_list L_EOS",
"dbhome : DBHOME STRING L_EOS",
"dbname : DBNAME STRING L_EOS",
"db_cache_mem : DB_CACHE_MEM num L_EOS",
"mem_max : MEM_MAX num L_EOS",
"lo_mark : LO_MARK num L_EOS",
"swap_advance : SWAP_ADVANCE_T num L_EOS",
"hi_mark : HI_MARK num L_EOS",
"num : NUMBER",
"offset : NUMBER",
"string : STRING",
"module : MODULE module_name '{' mod_ops '}' L_EOS",
"module : MODULE module_name '{' '}' L_EOS",
"mod_ops : mod_op",
"mod_ops : mod_ops mod_op",
"mod_op : string",
"module_name : STRING",
"storage : STORAGE '{' st_ops '}' L_EOS",
"peerconfig : PEER_PARENT_T ';'",
"peerconfig : PEER_SIBLING_T ';'",
"peerconfig : PEER_DOWN_TIMEOUT_T num ';'",
"peerconfig : MY_AUTH_T string ';'",
"peerconfig : PEER_ACCESS_T STRING ';'",
"peerconfig : allow_acl",
"peerconfig : deny_acl",
"peerops : peerconfig",
"peerops : peerops peerconfig",
"peer : PEER_T string num num '{' peerops '}' L_EOS",
"st_ops : st_op",
"st_ops : st_op st_ops",
"st_op : SIZE offset ';'",
"st_op : SIZE AUTO_T ';'",
"st_op : STORAGE_OFFSET_T offset ';'",
"st_op : PATH STRING ';'",
"group : GROUP group_name '{' group_ops '}' L_EOS",
"group_name : STRING",
"group_ops : group_op",
"group_ops : group_op group_ops",
"group_op : NETWORKS network_list ';'",
"group_op : SRCDOMAINS_T INCLUDE_T string ';' L_EOS",
"group_op : SRCDOMAINS_T domainlist ';'",
"group_op : NETWORKS_ACL_T string_list ';'",
"group_op : MAXREQRATE_T num ';'",
"group_op : bandwidth",
"group_op : per_sess_bw",
"group_op : per_ip_bw",
"group_op : per_ip_conn",
"group_op : conn_from",
"group_op : badports",
"group_op : http",
"group_op : icp",
"group_op : miss",
"group_op : denytime",
"group_op : auth_mods",
"group_op : redir_mods",
"denytime : DENYTIME_T string_list",
"miss : MISS_T DENY ';'",
"miss : MISS_T ALLOW ';'",
"auth_mods : AUTH_MODS_T string_list ';'",
"redir_mods : REDIR_MODS_T string_list ';'",
"bandwidth : BANDWIDTH_T num ';'",
"per_sess_bw : PER_SESS_BW_T num ';'",
"per_ip_bw : PER_IP_BW_T num ';'",
"per_ip_conn : PER_IP_CONN_T num ';'",
"conn_from : CONN_FROM_T string ';'",
"range : '[' num ':' num ']'",
"range : NUMBER",
"range : '[' string ']'",
"ranges : range",
"ranges : range ',' ranges",
"badports : BADPORTS_T ranges ';'",
"icp : ICP '{' deny_acls allow_acls '}'",
"icp : ICP '{' allow_acls deny_acls '}'",
"icp : ICP '{' allow_acls '}'",
"icp : ICP '{' deny_acls '}'",
"http : HTTP '{' deny_acls allow_acls '}'",
"http : HTTP '{' allow_acls deny_acls '}'",
"http : HTTP '{' allow_acls '}'",
"http : HTTP '{' deny_acls '}'",
"deny_acls : deny_acl",
"deny_acls : deny_acl deny_acls",
"deny_acl : DENY DSTDOMAIN string_list ';'",
"allow_acls : allow_acl",
"allow_acls : allow_acl allow_acls",
"allow_acl : ALLOW DSTDOMAIN string_list ';'",
"string_list : string_list_e",
"string_list : string_list_e string_list",
"string_list : string_list_e ',' string_list",
"string_list_e : string",
"domainlist : domain",
"domainlist : domain domainlist",
"domain : STRING",
"network_list : network",
"network_list : network network_list",
"network : NETWORK",
};
#endif
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE


static void
add_to_stop_cache(char *string)
{
struct  string_list     *new;

    if ( (new = malloc(sizeof(*new))) ) {
	new->string = string;
	new->next = stop_cache;
	stop_cache = new;
    }
}

struct domain_list*
load_domlist_from_file(char* file)
{
FILE			*f;
struct	domain_list	*first=NULL, *new, *last=NULL;
char			buf[128], *p;

    f = fopen(file,"r");
    if ( !f ) {
	verb_printf("Failed to open file %s: %m\n", file);
	return(NULL);
    }
    /* read file - domain per line */
    while ( fgets(buf, sizeof(buf), f) ) {
	p = buf;
	if ( (p = memchr(buf, '\n', sizeof(buf))) ) *p = 0;
	/* skip leading spaces */
	p = buf;
	SKIP_SPACES(p);
	if ( !*p ) /* empty line */
	    continue;
	if ( *p == '#' ) /* comment */
	    continue;
	/* ok here is domain */
	if ( !(new = calloc(1, sizeof(*new))) ) {
	    if ( first ) free_dom_list(first);
	    fclose(f);
	    return(NULL);
	}
	new->domain = malloc(strlen(p)+1);
	if ( !new->domain ) {
	    if ( first ) free_dom_list(first);
	    fclose(f);
	    return(NULL);
	}
	strcpy(new->domain, p);
	if ( !strcmp(p, "*") )
		new->length = -1;
	    else
		new->length = strlen(p);
	if ( !first ) first = new;
	if ( last ) last->next = new;
	last = new;
    }
    fclose(f);
    return(first);
}

struct domain_list*
load_domlist_from_list(struct string_list *list)
{
struct	domain_list	*first=NULL, *new, *last=NULL;

    while ( list && list->string ) {
	if ( !(new = calloc(1, sizeof(*new))) ) {
	    if ( first ) free_dom_list(first);
	    return(NULL);
	}
	new->domain = strdup(list->string);
	if ( !new->domain ) {
	    if ( first ) free_dom_list(first);
	    return(NULL);
	}
	if ( !strcmp(new->domain, "*") )
		new->length = -1;
	    else
		new->length = strlen(new->domain);
	if ( !first ) first = new;
	if ( last ) last->next = new;
	last = new;
	list = list->next;
    }
    return(first);
}

int
readconfig(char *name)
{
FILE		*cf;
int		code;

    cf = fopen(name, "r");
    if ( !cf ) {
	perror("readconfig");
	exit(1);
    }
    yyin = cf;
    atline = 1;
    conf_file_name = strdup(name);
    ns_curr = 0;
    memset(&peer_c, 0, sizeof(peer_c));
    peer_c.type  = PEER_SIBLING;
    peer_c.down_timeout = 60;
    peerc_ptr = NULL;
    memset((void*)&badports, 0, sizeof(badports));
    code = yyparse();
    ns_configured = ns_curr;
    fclose(cf);
    printf("Parser returned %d, %d errors found\n", code, parser_errors);
    if ( parser_errors ) code = parser_errors;
    free(conf_file_name);
    return(code);
}

static int
string_to_days(struct denytime *dt, struct string_list *list)
{
unsigned char	res = 0;
char		*t, *tokptr, *tb;
int		start_m=0, end_m=0;

    if ( (dt == NULL) || (list == NULL) ) return(0);

    while ( list ) {
	tb = list->string;
	if ( list->next ) /* this must be dayspec */
	while( (t = (char*)strtok_r(tb, ",", &tokptr)) != 0 ) {
	    char          fday[4],tday[4];
	    unsigned char d1, d2, i;

	    tb = NULL;
	    if ( sscanf(t,"%3s:%3s", (char*)&fday,(char*)&tday) == 2 ) {
		verb_printf("string_to_days(): Day interval from: '%s' to '%s'\n", fday,tday);
		d1 = daybit(fday);
		d2 = daybit(tday);
		if ( TEST(d1, 0x80) || TEST(d2, 0x80) ) {
		    verb_printf("string_to_days(): Wrong daytime\n");
		    return(0);
		}
		i = d1;
		d2 <<= 1; if ( d2 > 64 ) d2 = 1;
		if ( d2 == d1 ) {
                    res |= daybit("all");
		} else {
		    while(i != d2) {
		        res |= i;
		        i <<= 1;
		        if ( i > 64 ) i = 1;
		    }
                }
	    } else {
		verb_printf("string_to_days(): Day: '%s'\n", t);
		res |= daybit(t);
	    }  
	} else /* this must be timespec */ {
	    if ( list->string && (sscanf(list->string, "%d:%d", &start_m, &end_m) != 2) ) {
		verb_printf("Wrong timespec: %s\n", list->string);
		return(0);
	    }
	    verb_printf("string_to_days(): %0.4d-%0.4d\n", start_m, end_m);
	    dt->start_minute = 60*(start_m/100) + start_m%100;
	    dt->end_minute = 60*(end_m/100) + end_m%100;
	}
	list = list->next;
    }
    dt->days = res;
    return(0);
}
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 66:
{
			yyerrok;
		  }
break;
case 68:
{
			verb_printf("LOGFILE:\t<<%s>>\n", yyvsp[-1].STRPTR);
			strncpy(logfile, yyvsp[-1].STRPTR, sizeof(logfile)-1);
			free(yyvsp[-1].STRPTR);
			logfile_buffered = FALSE;
			printf("Making logfile %s unbuffered.\n", logfile);
		}
break;
case 69:
{
			verb_printf("LOGFILE:\t<<%s>>\n", yyvsp[-2].STRPTR);
			strncpy(logfile, yyvsp[-2].STRPTR, sizeof(logfile)-1);
			free(yyvsp[-2].STRPTR);
			if ( !strcasecmp(yyvsp[-1].STRPTR, "buffered") ) {
			    logfile_buffered = TRUE;
			    printf("Making logfile %s buffered.\n", logfile);
			} else if ( !strcasecmp(yyvsp[-1].STRPTR, "unbuffered") ) {
			    logfile_buffered = FALSE;
			    printf("Making logfile %s unbuffered.\n", logfile);
			} else {
			    printf("Last parameter of logfile statement can be `buffered' or `unbuffered': %s\n", yyvsp[-1].STRPTR);
			    logfile_buffered = FALSE;
			    printf("Making logfile %s unbuffered.\n", logfile);
			}
			free(yyvsp[-1].STRPTR);
		}
break;
case 70:
{
			verb_printf("LOGFILE:\t<<%s>> num: %d, size: %d\n",
			yyvsp[-5].STRPTR, yyvsp[-3].INT, yyvsp[-2].INT);
			strncpy(logfile, yyvsp[-5].STRPTR, sizeof(logfile)-1);
			log_num = yyvsp[-3].INT;
			log_size = yyvsp[-2].INT;
			free(yyvsp[-5].STRPTR);
			logfile_buffered = FALSE;
			printf("Making logfile %s unbuffered.\n", logfile);
		}
break;
case 71:
{
			verb_printf("LOGFILE:\t<<%s>> num: %d, size: %d\n",
			yyvsp[-6].STRPTR, yyvsp[-4].INT, yyvsp[-3].INT);
			strncpy(logfile, yyvsp[-6].STRPTR, sizeof(logfile)-1);
			log_num = yyvsp[-4].INT;
			log_size = yyvsp[-3].INT;
			free(yyvsp[-6].STRPTR);
			if ( !strcasecmp(yyvsp[-1].STRPTR, "buffered") ) {
			    logfile_buffered = TRUE;
			    printf("Making logfile %s buffered.\n", logfile);
			} else if ( !strcasecmp(yyvsp[-1].STRPTR, "unbuffered") ) {
			    logfile_buffered = FALSE;
			    printf("Making logfile %s unbuffered.\n", logfile);
			} else {
			    printf("Last parameter of logfile statement can be `buffered' or `unbuffered': %s\n", yyvsp[-1].STRPTR);
			    logfile_buffered = FALSE;
			    printf("Making logfile %s unbuffered.\n", logfile);
			}
			free(yyvsp[-1].STRPTR);
		}
break;
case 72:
{
			oops_user = yyvsp[-1].STRPTR;
		}
break;
case 73:
{
                        ftp_passw = yyvsp[-1].STRPTR;
                }
break;
case 74:
{
			oops_chroot = yyvsp[-1].STRPTR;
		}
break;
case 75:
{
			blacklist_len = yyvsp[-1].INT;
		}
break;
case 76:
{
			refuse_at = yyvsp[-1].INT;
		}
break;
case 77:
{
			start_red = yyvsp[-1].INT;
		}
break;
case 78:
{
			dont_cache_without_last_modified = TRUE;
		}
break;
case 79:
{
			if ( !strcasecmp(yylval.STRPTR, "yes") )
				insert_x_forwarded_for = TRUE;
			   else
			if (!strcasecmp(yylval.STRPTR, "no") )
				insert_x_forwarded_for = FALSE;
			   else
				printf("insert_x_forwarded_for can be 'yes' or 'no'\n");
			free(yylval.STRPTR);
		}
break;
case 80:
{
			if ( !strcasecmp(yylval.STRPTR, "yes") )
				fetch_with_client_speed = TRUE;
			   else
			if (!strcasecmp(yylval.STRPTR, "no") )
				fetch_with_client_speed = FALSE;
			   else
				printf("fetch_with_client_speed can be 'yes' or 'no'\n");
			free(yylval.STRPTR);
		}
break;
case 81:
{
			if ( !strcasecmp(yylval.STRPTR, "yes") )
				insert_via = TRUE;
			   else
			if (!strcasecmp(yylval.STRPTR, "no") )
				insert_via = FALSE;
			   else
				printf("insert_via can be 'yes' or 'no'\n");
			free(yylval.STRPTR);
		}
break;
case 82:
{
			verb_printf("ACCESSLOG:\t<<%s>>\n", yyvsp[-1].STRPTR);
			strncpy(accesslog, yyvsp[-1].STRPTR, sizeof(accesslog)-1);
			accesslog_num = accesslog_size = 0;
			free(yyvsp[-1].STRPTR);
			accesslog_buffered = FALSE;
			printf("Making accesslog %s unbuffered.\n", accesslog);
		}
break;
case 83:
{
			verb_printf("ACCESSLOG:\t<<%s>>\n",
			yyvsp[-2].STRPTR);
			strncpy(accesslog, yyvsp[-2].STRPTR, sizeof(accesslog)-1);
			free(yyvsp[-2].STRPTR);
			if ( !strcasecmp(yyvsp[-1].STRPTR, "buffered") ) {
			    accesslog_buffered = TRUE;
			    printf("Making accesslog %s buffered.\n", accesslog);
			} else if ( !strcasecmp(yyvsp[-1].STRPTR, "unbuffered") ) {
			    accesslog_buffered = FALSE;
			    printf("Making accesslog %s unbuffered.\n", accesslog);
			} else {
			    printf("Last parameter of accesslog statement can be `buffered' or `unbuffered': %s\n", yyvsp[-1].STRPTR);
			    accesslog_buffered = FALSE;
			    printf("Making accesslog %s unbuffered.\n", accesslog);
			}
			free(yyvsp[-1].STRPTR);
		}
break;
case 84:
{
			verb_printf("ACCESSLOG:\t<<%s>> num: %d, size: %d\n",
			yyvsp[-5].STRPTR, yyvsp[-3].INT, yyvsp[-2].INT);
			strncpy(accesslog, yyvsp[-5].STRPTR, sizeof(accesslog)-1);
			accesslog_num = yyvsp[-3].INT;
			accesslog_size = yyvsp[-2].INT;
			free(yyvsp[-5].STRPTR);
			accesslog_buffered = FALSE;
			printf("Making accesslog %s unbuffered.\n", accesslog);
		}
break;
case 85:
{
			verb_printf("ACCESSLOG:\t<<%s>> num: %d, size: %d\n",
			yyvsp[-6].STRPTR, yyvsp[-4].INT, yyvsp[-3].INT);
			strncpy(accesslog, yyvsp[-6].STRPTR, sizeof(accesslog)-1);
			accesslog_num = yyvsp[-4].INT;
			accesslog_size = yyvsp[-3].INT;
			free(yyvsp[-6].STRPTR);
			if ( !strcasecmp(yyvsp[-1].STRPTR, "buffered") ) {
			    accesslog_buffered = TRUE;
			    printf("Making accesslog %s buffered.\n", accesslog);
			} else if ( !strcasecmp(yyvsp[-1].STRPTR, "unbuffered") ) {
			    accesslog_buffered = FALSE;
			    printf("Making accesslog %s unbuffered.\n", accesslog);
			} else {
			    printf("Last parameter of accesslog statement can be `buffered' or `unbuffered': %s\n", yyvsp[-1].STRPTR);
			    accesslog_buffered = FALSE;
			    printf("Making accesslog %s unbuffered.\n", accesslog);
			}
			free(yyvsp[-1].STRPTR);
		}
break;
case 86:
{
			char	*buf;
			int	len;
			len = strlen(yyvsp[-4].STRPTR) + strlen(yyvsp[-2].STRPTR) + 20 ;
			if ( (buf = malloc(len)) ) {
			    snprintf(buf, len, "%s %d %s %d", yyvsp[-4].STRPTR, yyvsp[-3].INT, yyvsp[-2].STRPTR, yyvsp[-1].INT);
			    parse_refresh_pattern(&global_refresh_pattern, buf);
			    free(buf);
			}
			free(yyvsp[-4].STRPTR);
			free(yyvsp[-2].STRPTR);
		}
break;
case 87:
{
			parse_bind_acl(yylval.STRPTR);
			free(yylval.STRPTR);
		}
break;
case 88:
{
			parse_acl_access(&acl_allow, yylval.STRPTR);
			free(yylval.STRPTR);
		}
break;
case 89:
{
			parse_acl_access(&acl_deny, yylval.STRPTR);
			free(yylval.STRPTR);
		}
break;
case 90:
{
			parse_acl_access(&stop_cache_acl, yylval.STRPTR);
			free(yylval.STRPTR);
		}
break;
case 91:
{
			char		  *token, *p, *tptr;
			char		  *n=NULL, *type=NULL, *data=NULL;
			struct	named_acl *new_acl;
			int		  acl_type, res;

			printf("Named ACL %s\n", yylval.STRPTR);
			if ( !(new_acl = calloc(1, sizeof(*new_acl))) ) goto error;
			/* must be 
			   name type data
			*/
			p = yylval.STRPTR;
			printf("DATA: %s\n", p);
			tptr = p;
			while( 1 ) {
			    char	op;
			    token = p+1;
			    SKIP_SPACES(token);
			    if ( !*token ) break;
			    p = token; while ( *p && !IS_SPACE(*p) ) p++;
			    op = *p;
			    *p = 0;
			    if ( !n ) {
				n = token;
				strncpy((char*)&new_acl->name, n, sizeof(new_acl->name)-1);
				continue;
			    }
			    if ( !type ) {
				type = token;
				acl_type = named_acl_type_by_name(type);
				if ( acl_type == -1 ) {
				    printf("Unknown acl type %s\n", type);
				    goto error;
				}
				new_acl->type = acl_type;
				continue;
			    }
			    if ( !data ) {
				data = token;
				*p = op;
				break;
			    }
			}
			if ( !data ) goto error;
			res = parse_named_acl_data(new_acl, data);
			if ( res ) {
			    printf("Unparsable acl data `%s'.\n", data);
			    goto error;
			}
			insert_named_acl_in_list(new_acl);
			goto done;
		error:
			if ( new_acl ) free_named_acl(new_acl);
		done:;
			free(yylval.STRPTR);
		}
break;
case 92:
{
			verb_printf("STATISTICS:\t<<%s>>\n", yylval.STRPTR);
			strncpy(statisticslog, yylval.STRPTR, sizeof(statisticslog)-1);
			free(yylval.STRPTR);
		}
break;
case 93:
{
			verb_printf("PIDFILE:\t<<%s>>\n", yylval.STRPTR);
			strncpy(pidfile, yylval.STRPTR, sizeof(pidfile)-1);
			free(yylval.STRPTR);
		}
break;
case 94:
{
			verb_printf("NAMESERVER:\t<<%s>>\n", yylval.STRPTR);
			if ( ns_curr < OOPSMAXNS ) {
			    memset(&ns_sa[ns_curr], 0, sizeof(ns_sa[ns_curr]));
			    ns_sa[ns_curr].sin_family = AF_INET;
#if	!defined(SOLARIS) && !defined(LINUX) && !defined(OSF) && !defined(_WIN32) && !defined(__OS2__)
			    ns_sa[ns_curr].sin_len = sizeof(ns_sa[ns_curr]);
#endif
			    ns_sa[ns_curr].sin_addr.s_addr = inet_addr(yylval.STRPTR);
			    ns_sa[ns_curr].sin_port = htons(53);
			    ns_curr++;
			} else {
			    verb_printf("You can configure maximum %d nameservers\n", OOPSMAXNS);
			}
			free(yylval.STRPTR);
		}
break;
case 95:
{
			char	*p;
			strncpy(connect_from, yylval.STRPTR, sizeof(connect_from)-1);
			free(yylval.STRPTR);
			p = connect_from;
			while ( *p ) { *p=tolower(*p); p++; }
			verb_printf("CONNECT_FROM:\t<<%s>>\n", connect_from);
		}
break;
case 96:
{
			verb_printf("STOP_CACHE:\t<<%s>>\n", yylval.STRPTR);
			add_to_stop_cache(yylval.STRPTR);
		}
break;
case 97:
{
			verb_printf("MAXRESIDENT:\t %d\n", yylval.INT);
			maxresident = yylval.INT;
		}
break;
case 98:
{
			verb_printf("MINRESIDENT:\t %d\n", yylval.INT);
			minresident = yylval.INT;
		}
break;
case 99:
{
			bind_addr = yyvsp[-1].STRPTR;
		}
break;
case 100:
{
			verb_printf("HTTP_PORT\t<<%d>>\n", yylval.INT);
			http_port = yylval.INT;
		}
break;
case 101:
{
			verb_printf("ICP_PORT\t<<%d>>\n", yylval.INT);
			icp_port = yylval.INT;
		}
break;
case 102:
{
			verb_printf("ICP_TIMEOUT\t<<%d>>\n", yylval.INT);
			icp_timeout = 1000*yylval.INT;
		}
break;
case 103:
{
			verb_printf("NEGATIVE_CACHE\t<<%d>>\n", yylval.INT);
			negative_cache = yylval.INT;
		}
break;
case 104:
{
			verb_printf("ICONS_HOST:\t<<%s>>\n", yylval.STRPTR);
			strncpy(icons_host, yylval.STRPTR, sizeof(icons_host)-1);
			free(yylval.STRPTR);
		}
break;
case 105:
{
			verb_printf("ICONS_PORT:\t<<%d>>\n", yylval.INT);
			sprintf(icons_port, "%d", yylval.INT);
		}
break;
case 106:
{
			verb_printf("ICONS_PATH:\t<<%s>>\n", yylval.STRPTR);
			strncpy(icons_path, yylval.STRPTR, sizeof(icons_path)-1);
			free(yylval.STRPTR);
		}
break;
case 107:
{
			verb_printf("ALWAYS CHECK FRESHNESS\n");
			always_check_freshness = TRUE;
		}
break;
case 108:
{
			verb_printf("ALWAYS CHECK FRESHNESS ACL\n");
			parse_acl_access(&always_check_freshness_acl, yylval.STRPTR);
			free(yylval.STRPTR);
		}
break;
case 109:
{
			verb_printf("FORCE_HTTP11\n");
			force_http11 = TRUE;
		}
break;
case 110:
{
			verb_printf("FORCE_COMPLETION: %d%%\n", yylval.INT);
			force_completion = yylval.INT;
		}
break;
case 111:
{
			verb_printf("LAST_MODIFIED_FACTOR: %d\n", yylval.INT);
			last_modified_factor = yylval.INT;
		}
break;
case 112:
{
			verb_printf("EXPIRE_VALUE:\t<<%d days>>\n", yylval.INT);
			default_expire_value=yylval.INT * 24 * 3600;
		}
break;
case 113:
{
		    struct	denytime		*denytime;
		    int		start_m, end_m;
		    char m1[10], m2[10];

		    if ( (expiretime = calloc(1, sizeof(*expiretime))) != NULL )
		        string_to_days(expiretime, yyvsp[0].STRING_LIST);
		    free_string_list(yyvsp[0].STRING_LIST);
		}
break;
case 114:
{
			verb_printf("MAX_EXPIRE_VALUE:\t<<%d days>>\n", yylval.INT);
			max_expire_value=yylval.INT * 24 * 3600;
		}
break;
case 115:
{
			verb_printf("FTP_EXPIRE_VALUE:\t<<%d days>>\n", yylval.INT);
			ftp_expire_value=yylval.INT * 24 * 3600;
		}
break;
case 116:
{
			verb_printf("EXPIRE_INTERVAL:<<%d hours>>\n", yylval.INT);
			default_expire_interval=yylval.INT * 3600;
		}
break;
case 117:
{
			verb_printf("DISK_LOW_FREE:\t<<%d %%>>\n", yylval.INT);
			disk_low_free=yylval.INT ;
		}
break;
case 118:
{
			verb_printf("DISK_HI_FREE:\t<<%d %%>>\n", yylval.INT);
			disk_hi_free=yylval.INT ;
		}
break;
case 119:
{
			verb_printf("PARENT: %s:%d\n", yyvsp[-2].STRPTR, yyvsp[-1].INT);
			strncpy(parent_host, yyvsp[-2].STRPTR, sizeof(parent_host));
			parent_port = yyvsp[-1].INT;
			free(yyvsp[-2].STRPTR);
		}
break;
case 120:
{
			verb_printf("PARENT_AUTH: %s\n", yyvsp[-1].STRPTR);
			parent_auth = base64_encode(yyvsp[-1].STRPTR);
			free(yyvsp[-1].STRPTR);
		}
break;
case 121:
{
		    struct domain_list *d;
			verb_printf ("LOCAL_DOMAIN\n");
			if ( !local_domains) local_domains = yyvsp[-1].DOMAIN;
			else {
			    d = yyvsp[-1].DOMAIN;
			    while( d ) {
				if ( !d->next ) {
				    d->next = local_domains;
				    local_domains = yyvsp[-1].DOMAIN;
				    break;
				}
				d = d->next;
			    }
			}
		}
break;
case 122:
{
		    struct cidr_net *n;
			verb_printf ("LOCAL_NETWORKS\n");
			if ( !local_networks) local_networks = yyvsp[-1].NETPTR;
			else {
			    n = local_networks;
			    while( n ) {
				if ( !n->next ) {
				    n->next = yyvsp[-1].NETPTR;
				    break;
				}
				n = n->next;
			    }
			}
		}
break;
case 123:
{
			printf("WARNING!!!! dbhome must be moved to module berkeley_db\n");
			free(yylval.STRPTR);
		}
break;
case 124:
{
			printf("WARNING!!!! dbname must be moved to module berkeley_db\n");
			free(yylval.STRPTR);
		}
break;
case 125:
{
			printf("WARNING!!!! db_cache_mem must be moved to module berkeley_db\n");
		}
break;
case 126:
{
			verb_printf("MEM_MAX:\t<<%d>>\n", yyvsp[-1].INT);
			mem_max_val = yyvsp[-1].INT ;
		}
break;
case 127:
{
			verb_printf("LO_MARK:\t<<%d>>\n", yyvsp[-1].INT);
			lo_mark_val = yyvsp[-1].INT ;
		}
break;
case 128:
{
			verb_printf("SWAP_ADVANCE:\t<<%d>>\n", yyvsp[-1].INT);
			swap_advance = yyvsp[-1].INT ;
			if ( swap_advance <= 0 ) swap_advance = 1;
		}
break;
case 129:
{
			verb_printf("HI_MARK:\t<<%d>>\n", yyvsp[-1].INT);
			hi_mark_val = yyvsp[-1].INT ;
		}
break;
case 130:
{ yyval.INT = yylval.INT;}
break;
case 131:
{ yyval.OFFSET = yylval.OFFSET;}
break;
case 132:
{ yyval.STRPTR = yylval.STRPTR; }
break;
case 133:
{
			struct string_list	*list = yyvsp[-2].STRING_LIST;
			struct general_module	*mod;
			char			*modname, *inst;
			int			instance = 0;

			modname = yyvsp[-4].STRPTR;
			if ( (inst = strchr(yyvsp[-4].STRPTR, '/')) ) {
			    *inst = 0;
			    instance = atoi(++inst);
			}
			mod = module_by_name(modname);
			if ( mod ) {
			    verb_printf("Config %s / %d\n", modname, instance);
			    if ( mod->config_beg ) (*mod->config_beg)(instance);
			    while( list ) {
				verb_printf("send `%s' to `%s'.\n", list->string, yyvsp[-4].STRPTR);
				if (mod->config) (*mod->config)(list->string, instance);
				list = list->next;
			    }
			    if ( mod->config_end ) (*mod->config_end)(instance);
			    verb_printf("Done with %s / %d\n", modname, instance);
			} else {
			    verb_printf("Module %s not found\n", modname);
			}
			free_string_list(yyvsp[-2].STRING_LIST);
			free(yyvsp[-4].STRPTR);
		}
break;
case 134:
{
			struct general_module	*mod = module_by_name(yyvsp[-3].STRPTR);
			if ( mod && mod->config_beg ) (*mod->config_beg)(0);
			if ( mod && mod->config_end ) (*mod->config_end)(0);
			free(yyvsp[-3].STRPTR);
		}
break;
case 135:
{
			yyval.STRING_LIST = yyvsp[0].STRING_LIST;
			verb_printf("mod_op: %s\n", yyval.STRING_LIST->string);
		}
break;
case 136:
{
		    struct string_list *last = yyvsp[-1].STRING_LIST;
			while ( last->next ) last = last->next;
			last->next = yyvsp[0].STRING_LIST;
			yyval.STRING_LIST = yyvsp[-1].STRING_LIST;
			verb_printf("mod_op: %s\n", yyvsp[0].STRING_LIST->string);
		}
break;
case 137:
{
			struct string_list *new;
			char		   *new_str;

			if ( !(new = calloc(1, sizeof(*new))) ) yyerror();
			if ( !(new_str = malloc(strlen(yyvsp[0].STRPTR)+1)) ) yyerror();

			strcpy(new_str, yyvsp[0].STRPTR);
			free(yyvsp[0].STRPTR);
			new->string = new_str;
			yyval.STRING_LIST=new;
		}
break;
case 138:
{
			yyval.STRPTR = yylval.STRPTR;
		}
break;
case 139:
{
		    struct storage_st *new;
#if	defined(WITH_LARGE_FILES)
		    verb_printf("Storage: %s (size %lld bytes)\n", storage_path, storage_size);
#else
		    verb_printf("Storage: %s (size %d bytes)\n", storage_path, storage_size);
#endif
		    if ( !(new = calloc(1, sizeof(*new))) ) yyerror();

		    new->path = storage_path;
		    new->size = storage_size;
		    new->i_off = storage_offset;
		    new->fd = -1;
		    if ( !storages ) {
			storages = new;
		    } else {
			struct storage_st *tmp = storages;
			while(tmp->next) {
			    tmp=tmp->next;
			}
			tmp->next = new;
		    }
		    storage_path = NULL;
		    storage_size = 0;
		    storage_offset = 0;
		}
break;
case 140:
{
			if ( !peerc_ptr )
				peerc_ptr = &peer_c;
			peerc_ptr->type = PEER_PARENT;
		  }
break;
case 141:
{
			if ( !peerc_ptr )
				peerc_ptr = &peer_c;
			peerc_ptr->type = PEER_SIBLING;
		  }
break;
case 142:
{
			if ( !peerc_ptr )
				peerc_ptr = &peer_c;
			peerc_ptr->down_timeout = yyvsp[-1].INT ;
		  }
break;
case 143:
{
			if ( !peerc_ptr )
				peerc_ptr = &peer_c;
			peerc_ptr->my_auth = base64_encode(yyvsp[-1].STRPTR);
			free(yyvsp[-1].STRPTR);
		  }
break;
case 144:
{
			if ( !peerc_ptr )
				peerc_ptr = &peer_c;
			verb_printf("PEER_ACCESS: %s\n", yylval.STRPTR);
			parse_acl_access(&peerc_ptr->peer_access, yylval.STRPTR);
			free(yylval.STRPTR);
		  }
break;
case 145:
{
			if ( !peerc_ptr )
				peerc_ptr = &peer_c;
			if ( !peerc_ptr->acls ) {
			    if ( !(peerc_ptr->acls = calloc(1, sizeof(struct acls))) )
				yyerror();
			}
			yyvsp[0].ACL->next = peerc_ptr->acls->allow;
			peerc_ptr->acls->allow = yyvsp[0].ACL;
		  }
break;
case 146:
{
			if ( !peerc_ptr )
				peerc_ptr = &peer_c;
			if ( !peerc_ptr->acls ) {
			    if ( !(peerc_ptr->acls = calloc(1, sizeof(struct acls))) )
				yyerror();
			}
			yyvsp[0].ACL->next = peerc_ptr->acls->deny;
			peerc_ptr->acls->deny = yyvsp[0].ACL;
		  }
break;
case 147:
{}
break;
case 148:
{}
break;
case 149:
{
			struct	peer *peer,*p;

			if ( !(peer = calloc(1, sizeof(struct peer))) ) yyerror();

			peer->name      = yyvsp[-6].STRPTR;
			peer->http_port = yyvsp[-5].INT;
			peer->icp_port  = yyvsp[-4].INT;
			peer->state	= PEER_DOWN;
			if ( peerc_ptr ) {
			    peer->type = peerc_ptr->type;
			    peer->acls = peerc_ptr->acls;
			    peer->my_auth = peerc_ptr->my_auth;
			    peer->peer_access = peerc_ptr->peer_access;
			    peer->down_timeout = peerc_ptr->down_timeout;
			}
			/* insert peer in the list */
			if ( !peers ) {
			    peers = peer;
			} else {
			    p = peers;
			    while ( p->next ) p=p->next;
			    p->next = peer;
			}
			memset(&peer_c, 0, sizeof(peer_c));
			peer_c.type = PEER_SIBLING;
			peerc_ptr = NULL;
		}
break;
case 150:
{}
break;
case 151:
{}
break;
case 152:
{ storage_size = yyvsp[-1].OFFSET; }
break;
case 153:
{ storage_size = -1; }
break;
case 154:
{storage_offset = yyvsp[-1].OFFSET; }
break;
case 155:
{ storage_path = yylval.STRPTR; }
break;
case 156:
{
			struct	group_ops_struct *ops, *next_ops;
			struct	group	*new_grp, *g;

			if ( !(new_grp = calloc(1, sizeof(*new_grp))) ) yyerror();

			pthread_mutex_init(&new_grp->group_mutex, NULL);
			new_grp->name = yyvsp[-4].STRPTR;
			verb_printf("Group `%s'.\n", yyvsp[-4].STRPTR);
			ops = yyvsp[-2].GROUPOPS;
			while ( ops ) {
				next_ops = ops->next;
				switch(ops->op) {
				case OP_NETWORKS:
					new_grp->nets = ops->val;
					break;
				case OP_SRCDOMAINS:
					new_grp->srcdomains = ops->val;
					break;
				case OP_HTTP:
					new_grp->http = ops->val;
					break;
				case OP_ICP:
					new_grp->icp = ops->val;
					break;
				case OP_BADPORTS:
					new_grp->badports = ops->val;
					break;
				case OP_BANDWIDTH:
					new_grp->bandwidth = (int)ops->val;
					break;
				case OP_PER_SESS_BW:
					new_grp->per_sess_bw = (int)ops->val;
					break;
				case OP_PER_IP_BW:
					new_grp->per_ip_bw = (int)ops->val;
					break;
				case OP_PER_IP_CONN:
					new_grp->per_ip_conn = (int)ops->val;
					break;
				case OP_CONN_FROM:
					memcpy(&new_grp->conn_from_sa, ops->val, sizeof(new_grp->conn_from_sa));
					free(ops->val);
					break;
				case OP_MISS:
					new_grp->miss_deny = (int)ops->val;
					break;
				case OP_MAXREQRATE:
					new_grp->maxreqrate = (int)ops->val;
					break;
				case OP_AUTH_MODS:
					if ( ops->val ) {
					    new_grp->auth_mods =
						calloc(1, sizeof(*new_grp->auth_mods));
					    if (new_grp->auth_mods) {
						new_grp->auth_mods->list = ops->val;
						new_grp->auth_mods->refs = 1;
						pthread_mutex_init(&new_grp->auth_mods->lock, NULL);
					    }
					} else
					    new_grp->auth_mods = NULL;;
					break;
				case OP_REDIR_MODS:
					if ( ops->val ) {
					    new_grp->redir_mods =
						calloc(1, sizeof(*new_grp->redir_mods));
					    if (new_grp->redir_mods) {
						struct string_list	*l = ops->val;
						mod_call_t		*mc, *last=NULL;
						char			*sl;

						while ( l ) {
						    mc = calloc(1, sizeof(*mc));
						    if ( mc ) {
							if ( !last ) {
							    new_grp->redir_mods->list = mc;
							} else {
							    last->next = mc;
							}
							last = mc;
							strncpy(mc->mod_name, l->string, sizeof(mc->mod_name)-1);
							if ( (sl = strchr(mc->mod_name, '/')) ) {
							    *sl = 0;
							    mc->mod_instance = atoi(sl+1);
							}
							printf("%s:%d\n", mc->mod_name, mc->mod_instance);
						    }
						    l = l->next;
						}
						free_string_list(ops->val);
						new_grp->redir_mods->refs = 1;
						pthread_mutex_init(&new_grp->redir_mods->lock, NULL);
					    }
					} else
					    new_grp->redir_mods = NULL;;
					break;
				case OP_DENYTIME:
					((struct denytime*)(ops->val))->next = 
						new_grp->denytimes;
					new_grp->denytimes = ops->val;
					break;
				case OP_NETWORKS_ACL:
					/* list of acl
					   all must be known, all must be src_ip
					*/
					parse_networks_acl(&new_grp->networks_acl,
							  ops->val);
					free_string_list(ops->val);
					break;
				default:
					verb_printf("Unknown OP\n");
					break;
				}
				free(ops);
				ops = next_ops;
			}
			new_grp->next = 0;
			/* create acl/dstdomain cache */
			new_grp->dstdomain_cache = hash_init(128, HASH_KEY_STRING);
			if ( ! groups ) groups = new_grp;
                            else {
                                g = groups;
                                while( g->next ) g = g->next;
                                g->next = new_grp;
                        }
		}
break;
case 157:
{
			yyval.STRPTR = yylval.STRPTR;
		}
break;
case 158:
{ yyval.GROUPOPS = yyvsp[0].GROUPOPS;}
break;
case 159:
{ yyvsp[-1].GROUPOPS->next = yyvsp[0].GROUPOPS; yyval.GROUPOPS=yyvsp[-1].GROUPOPS;}
break;
case 160:
{
			struct	group_ops_struct	*new;
			if ( !(new = malloc(sizeof(*new))) ) yyerror();
			new->op  = OP_NETWORKS;
			new->val = yyvsp[-1].NETPTR;
			new->next= NULL;
			yyval.GROUPOPS = new;
		}
break;
case 161:
{
		}
break;
case 162:
{
			struct	group_ops_struct	*new;
			if ( !(new = malloc(sizeof(*new))) ) yyerror();
			new->op  = OP_SRCDOMAINS;
			new->val = yyvsp[-1].DOMAIN;
			new->next= NULL;
			yyval.GROUPOPS = new;
		}
break;
case 163:
{
			struct	group_ops_struct	*new;
			if ( !(new = malloc(sizeof(*new))) ) yyerror();
			new->op  = OP_NETWORKS_ACL;
			new->val = yyvsp[-1].STRING_LIST;
			new->next= NULL;
			yyval.GROUPOPS = new;
		}
break;
case 164:
{
			struct	group_ops_struct	*new;
			if ( !(new = malloc(sizeof(*new))) ) yyerror();
			new->op  = OP_MAXREQRATE;
			new->val = (void*)yyvsp[-1].INT;
			new->next= NULL;
			yyval.GROUPOPS = new;
		}
break;
case 165:
{ yyval.GROUPOPS = yyvsp[0].GROUPOPS; }
break;
case 166:
{ yyval.GROUPOPS = yyvsp[0].GROUPOPS; }
break;
case 167:
{ yyval.GROUPOPS = yyvsp[0].GROUPOPS; }
break;
case 168:
{ yyval.GROUPOPS = yyvsp[0].GROUPOPS; }
break;
case 169:
{ yyval.GROUPOPS = yyvsp[0].GROUPOPS; }
break;
case 170:
{ yyval.GROUPOPS = yyvsp[0].GROUPOPS; }
break;
case 171:
{ yyval.GROUPOPS = yyvsp[0].GROUPOPS; }
break;
case 172:
{ yyval.GROUPOPS = yyvsp[0].GROUPOPS; }
break;
case 173:
{ yyval.GROUPOPS = yyvsp[0].GROUPOPS; }
break;
case 174:
{ yyval.GROUPOPS = yyvsp[0].GROUPOPS; }
break;
case 175:
{ yyval.GROUPOPS = yyvsp[0].GROUPOPS; }
break;
case 176:
{ yyval.GROUPOPS = yyvsp[0].GROUPOPS; }
break;
case 177:
{
		    struct	group_ops_struct	*new_op;
		    struct	denytime		*denytime;
		    int		start_m, end_m;
			new_op = malloc(sizeof(*new_op));
			denytime = malloc(sizeof(*denytime));
			if ( !new_op || !denytime ) {
				yyerror();
				yyval.GROUPOPS = NULL;
			} else {
			    char m1[10], m2[10];
			    new_op->op = OP_DENYTIME;
			    memset(denytime, 0, sizeof(*denytime));
			    string_to_days(denytime, yyvsp[0].STRING_LIST);
			    new_op->val= (void*)denytime;
			    new_op->next=NULL;
			    yyval.GROUPOPS = new_op;
			}
			free_string_list(yyvsp[0].STRING_LIST);
		}
break;
case 178:
{
		    struct	group_ops_struct	*new_op;

			new_op = malloc(sizeof(*new_op));
			if ( !new_op ) {
				yyerror();
				yyval.GROUPOPS = NULL;
			} else {
			    new_op->op = OP_MISS;
			    verb_printf("MISS DENY\n");
			    new_op->val= (void*)TRUE;
			    new_op->next=NULL;
			    yyval.GROUPOPS = new_op;
			}
		}
break;
case 179:
{
		    struct	group_ops_struct	*new_op;

			new_op = malloc(sizeof(*new_op));
			if ( !new_op ) {
				yyerror();
				yyval.GROUPOPS = NULL;
			} else {
			    new_op->op = OP_MISS;
			    verb_printf("MISS ALLOWED\n");
			    new_op->val= (void*)FALSE;
			    new_op->next=NULL;
			    yyval.GROUPOPS = new_op;
			}
		}
break;
case 180:
{
		    struct	group_ops_struct	*new_op;

			new_op = malloc(sizeof(*new_op));
			if ( !new_op ) {
				yyerror();
				yyval.GROUPOPS = NULL;
			} else {
			    new_op->op = OP_AUTH_MODS;
			    verb_printf("AUTH_MODS\n");
			    new_op->val= yyvsp[-1].STRING_LIST;
			    new_op->next=NULL;
			    yyval.GROUPOPS = new_op;
			}
		}
break;
case 181:
{
		    struct	group_ops_struct	*new_op;

			new_op = malloc(sizeof(*new_op));
			if ( !new_op ) {
				yyerror();
				yyval.GROUPOPS = NULL;
			} else {
			    new_op->op = OP_REDIR_MODS;
			    verb_printf("REDIR_MODS\n");
			    new_op->val= yyvsp[-1].STRING_LIST;
			    new_op->next=NULL;
			    yyval.GROUPOPS = new_op;
			}
		}
break;
case 182:
{
		    struct	group_ops_struct	*new_op;

			new_op = malloc(sizeof(*new_op));
			if ( !new_op ) {
				yyerror();
				yyval.GROUPOPS = NULL;
			} else {
			    new_op->op = OP_BANDWIDTH;
			    verb_printf("Bandwidth %dbytes/sec\n", yyvsp[-1].INT);
			    new_op->val= (void*)yyvsp[-1].INT;
			    new_op->next=NULL;
			    yyval.GROUPOPS = new_op;
			}
		}
break;
case 183:
{
		    struct	group_ops_struct	*new_op;

			new_op = malloc(sizeof(*new_op));
			if ( !new_op ) {
				yyerror();
				yyval.GROUPOPS = NULL;
			} else {
			    new_op->op = OP_PER_SESS_BW;
			    verb_printf("Per session Bandwidth %dbytes/sec\n", yyvsp[-1].INT);
			    new_op->val= (void*)yyvsp[-1].INT;
			    new_op->next=NULL;
			    yyval.GROUPOPS = new_op;
			}
		}
break;
case 184:
{
		    struct	group_ops_struct	*new_op;

			new_op = malloc(sizeof(*new_op));
			if ( !new_op ) {
				yyerror();
				yyval.GROUPOPS = NULL;
			} else {
			    new_op->op = OP_PER_IP_BW;
			    verb_printf("Per IP Bandwidth %dbytes/sec\n", yyvsp[-1].INT);
			    new_op->val= (void*)yyvsp[-1].INT;
			    new_op->next=NULL;
			    yyval.GROUPOPS = new_op;
			}
		}
break;
case 185:
{
		    struct	group_ops_struct	*new_op;

			new_op = malloc(sizeof(*new_op));
			if ( !new_op ) {
				yyerror();
				yyval.GROUPOPS = NULL;
			} else {
			    new_op->op = OP_PER_IP_CONN;
			    verb_printf("Per IP Connections limit: %d\n", yyvsp[-1].INT);
			    new_op->val= (void*)yyvsp[-1].INT;
			    new_op->next=NULL;
			    yyval.GROUPOPS = new_op;
			}
		}
break;
case 186:
{
		    struct	group_ops_struct	*new_op;

		    new_op = malloc(sizeof(*new_op));
		    if ( !new_op ) {
			yyerror();
			yyval.GROUPOPS = NULL;
		    } else {
			char			c_from[64], *p;
			struct sockaddr_in	*c_from_sa_p;
			c_from_sa_p = calloc(1, sizeof(*c_from_sa_p));
			strncpy(c_from, yyvsp[-1].STRPTR, sizeof(c_from)-1);
			p = c_from;
			while ( *p ) { *p = tolower(*p); p++; }
			verb_printf("Group conn_from: %s\n", c_from);

			if ( str_to_sa(c_from, (struct sockaddr*)c_from_sa_p) ) {
			    verb_printf("WARNING: Can't resolve group connect_from %s, function disabled.\n", c_from);
			    memset(c_from_sa_p, 0, sizeof(*c_from_sa_p));
			} else
			    verb_printf("Group connect_from %s enabled.\n", c_from);
			new_op->op = OP_CONN_FROM;
			new_op->val = (void*)c_from_sa_p;
			new_op->next = NULL;
			yyval.GROUPOPS = new_op;
		    }
		}
break;
case 187:
{
			if ( !badp_p ) badp_p = &badports[0];
			badp_p->from = yyvsp[-3].INT;
			badp_p->length = yyvsp[-1].INT-yyvsp[-3].INT+1;
			if ( badp_p < &badports[MAXBADPORTS] ) badp_p++;
			    else {
			    verb_printf("You can use max %d badports ranges\n", MAXBADPORTS);
				badp_p--;
			    }
			}
break;
case 188:
{
			if ( !badp_p ) badp_p = &badports[0];
			badp_p->from = yylval.INT;
			badp_p->length = 1;
			if ( badp_p < &badports[MAXBADPORTS] ) badp_p++;
			    else {
			    verb_printf("You can use max %d badports ranges\n", MAXBADPORTS);
				badp_p--;
			    }
			}
break;
case 189:
{
			int	from, to;
			/* this must be [port:port] */
			if ( !badp_p ) badp_p = &badports[0];
			    if ( sscanf(yyvsp[-1].STRPTR, "%d:%d", &from, &to) == 2 ) {
				badp_p->from = from;
				badp_p->length = to - from + 1;
				if ( badp_p < &badports[MAXBADPORTS] ) badp_p++;
				    else {
				    verb_printf("You can use max %d badports ranges\n", MAXBADPORTS);
					badp_p--;
				    }
			    } else {
				printf("Unrecognized format: %s\n", yyvsp[-1].STRPTR);
			    }
			    free(yyvsp[-1].STRPTR);
			}
break;
case 190:
{}
break;
case 191:
{}
break;
case 192:
{
		    struct	group_ops_struct	*new_op;

			new_op = malloc(sizeof(*new_op));
			if ( !new_op ) {
				yyerror();
				yyval.GROUPOPS = NULL;
			} else {
			    struct range *val;
			    val = malloc(sizeof(*val)*MAXBADPORTS);
			    badp_p = NULL;
			    if ( !val ) {
				yyerror();
				yyval.GROUPOPS=NULL;
			    } else {
				memcpy((void*)val, (void*)&badports, sizeof(badports));
				memset((void*)&badports, 0, sizeof(badports));
				new_op->op = OP_BADPORTS;
				new_op->val= val;
				new_op->next=NULL;
				yyval.GROUPOPS = new_op;
			    }
			}
		}
break;
case 193:
{
			struct	acls			*new_acls;
			struct	group_ops_struct	*new_op;

			new_op = malloc(sizeof(*new_op));
			if ( !new_op ) {
				yyerror();
				yyval.GROUPOPS = NULL;
			} else {
				new_acls = malloc(sizeof(*new_acls));
				if ( !new_acls ) {
					verb_printf("No mem at http acl\n");
					yyerror();
					free(new_op);
					yyval.GROUPOPS = NULL;
				} else {
					new_acls->deny  = yyvsp[-2].ACL;
					new_acls->allow = yyvsp[-1].ACL;
					new_op->op  = OP_ICP;
					new_op->val = new_acls;
					new_op->next= NULL;
					yyval.GROUPOPS = new_op;
				}
			}
		}
break;
case 194:
{
			struct	acls			*new_acls;
			struct	group_ops_struct	*new_op;

			new_op = malloc(sizeof(*new_op));
			if ( !new_op ) {
				yyerror();
				yyval.GROUPOPS = NULL;
			} else {
				new_acls = malloc(sizeof(*new_acls));
				if ( !new_acls ) {
					verb_printf("No mem at http acl\n");
					yyerror();
					free(new_op);
					yyval.GROUPOPS = NULL;
				} else {
					new_acls->allow = yyvsp[-2].ACL;
					new_acls->deny  = yyvsp[-1].ACL;
					new_op->op  = OP_ICP;
					new_op->val = new_acls;
					new_op->next= NULL;
					yyval.GROUPOPS = new_op;
				}
			}
		}
break;
case 195:
{
			struct	acls		*new_acls;
			struct	group_ops_struct	*new_op;

			new_op = malloc(sizeof(*new_op));
			if ( !new_op ) {
				yyerror();
				yyval.GROUPOPS = NULL;
			} else {
				new_acls = malloc(sizeof(*new_acls));
				if ( !new_acls ) {
					verb_printf("No mem at icp acl\n");
					yyerror();
					free(new_op);
					yyval.GROUPOPS = NULL;
				} else {
					new_acls->allow = yyvsp[-1].ACL;
					new_acls->deny  = NULL;
					new_op->op  = OP_ICP;
					new_op->val = new_acls;
					new_op->next= NULL;
					yyval.GROUPOPS = new_op;
				}
			}
		}
break;
case 196:
{
			struct	acls		*new_acls;
			struct	group_ops_struct	*new_op;

			new_op = malloc(sizeof(*new_op));
			if ( !new_op ) {
				yyerror();
				yyval.GROUPOPS = NULL;
			} else {
				new_acls = malloc(sizeof(*new_acls));
				if ( !new_acls ) {
					verb_printf("No mem at icp acl\n");
					yyerror();
					free(new_op);
					yyval.GROUPOPS = NULL;
				} else {
					new_acls->deny  = yyvsp[-1].ACL;
					new_acls->allow = NULL;
					new_op->op  = OP_ICP;
					new_op->val = new_acls;
					new_op->next= NULL;
					yyval.GROUPOPS = new_op;
				}
			}
		}
break;
case 197:
{
			struct	acls			*new_acls;
			struct	group_ops_struct	*new_op;

			new_op = malloc(sizeof(*new_op));
			if ( !new_op ) {
				yyerror();
				yyval.GROUPOPS = NULL;
			} else {
				new_acls = malloc(sizeof(*new_acls));
				if ( !new_acls ) {
					verb_printf("No mem at http acl\n");
					yyerror();
					free(new_op);
					yyval.GROUPOPS = NULL;
				} else {
					new_acls->deny  = yyvsp[-2].ACL;
					new_acls->allow = yyvsp[-1].ACL;
					new_op->op  = OP_HTTP;
					new_op->val = new_acls;
					new_op->next= NULL;
					yyval.GROUPOPS = new_op;
				}
			}
		}
break;
case 198:
{
			struct	acls			*new_acls;
			struct	group_ops_struct	*new_op;

			new_op = malloc(sizeof(*new_op));
			if ( !new_op ) {
				yyerror();
				yyval.GROUPOPS = NULL;
			} else {
				new_acls = malloc(sizeof(*new_acls));
				if ( !new_acls ) {
					verb_printf("No mem at http acl\n");
					yyerror();
					free(new_op);
					yyval.GROUPOPS = NULL;
				} else {
					new_acls->allow = yyvsp[-2].ACL;
					new_acls->deny  = yyvsp[-1].ACL;
					new_op->op  = OP_HTTP;
					new_op->val = new_acls;
					new_op->next= NULL;
					yyval.GROUPOPS = new_op;
				}
			}
		}
break;
case 199:
{
			struct	acls		*new_acls;
			struct	group_ops_struct	*new_op;

			new_op = malloc(sizeof(*new_op));
			if ( !new_op ) {
				yyerror();
				yyval.GROUPOPS = NULL;
			} else {
				new_acls = malloc(sizeof(*new_acls));
				if ( !new_acls ) {
					verb_printf("No mem at http acl\n");
					yyerror();
					free(new_op);
					yyval.GROUPOPS = NULL;
				} else {
					new_acls->allow = yyvsp[-1].ACL;
					new_acls->deny  = NULL;
					new_op->op  = OP_HTTP;
					new_op->val = new_acls;
					new_op->next= NULL;
					yyval.GROUPOPS = new_op;
				}
			}
		}
break;
case 200:
{
			struct	acls		*new_acls;
			struct	group_ops_struct	*new_op;

			new_op = malloc(sizeof(*new_op));
			if ( !new_op ) {
				yyerror();
				yyval.GROUPOPS = NULL;
			} else {
				new_acls = malloc(sizeof(*new_acls));
				if ( !new_acls ) {
					verb_printf("No mem at http acl\n");
					yyerror();
					free(new_op);
					yyval.GROUPOPS = NULL;
				} else {
					new_acls->deny  = yyvsp[-1].ACL;
					new_acls->allow = NULL;
					new_op->op  = OP_HTTP;
					new_op->val = new_acls;
					new_op->next= NULL;
					yyval.GROUPOPS = new_op;
				}
			}
		}
break;
case 201:
{ yyval.ACL = yyvsp[0].ACL; }
break;
case 202:
{ yyvsp[0].ACL->next = yyvsp[-1].ACL ; yyval.ACL = yyvsp[0].ACL; }
break;
case 203:
{ 
			struct acl *new = malloc(sizeof(*new));
			if ( !new ) {
				verb_printf("No mem for acl\n");
				yyerror();
				yyval.ACL = NULL;
			} else {
				yyval.ACL = new;
				if ( yyvsp[-1].STRING_LIST
				     && yyvsp[-1].STRING_LIST->string
				     && !strncasecmp(yyvsp[-1].STRING_LIST->string,"include:",8) )
				   yyval.ACL->list =
					load_domlist_from_file(yyvsp[-1].STRING_LIST->string + 8);
				else
				   yyval.ACL->list = load_domlist_from_list(yyvsp[-1].STRING_LIST);
				yyval.ACL->next = NULL;
				yyval.ACL->type = ACL_DOMAINDST ;
			}
			free_string_list(yyvsp[-1].STRING_LIST);
		}
break;
case 204:
{ yyval.ACL = yyvsp[0].ACL; }
break;
case 205:
{ yyvsp[-1].ACL->next = yyvsp[0].ACL ; yyval.ACL = yyvsp[-1].ACL; }
break;
case 206:
{
			struct acl *new = malloc(sizeof(*new));
			if ( !new ) {
				verb_printf("No mem for acl\n");
				yyerror();
				yyval.ACL = NULL;
			} else {
				yyval.ACL = new;
				if ( yyvsp[-1].STRING_LIST
				     && yyvsp[-1].STRING_LIST->string
				     && !strncasecmp(yyvsp[-1].STRING_LIST->string,"include:",8) )
				   yyval.ACL->list =
					load_domlist_from_file(yyvsp[-1].STRING_LIST->string + 8);
				else
				   yyval.ACL->list = load_domlist_from_list(yyvsp[-1].STRING_LIST);
				yyval.ACL->next = NULL;
				yyval.ACL->type = ACL_DOMAINDST ;
			}
			free_string_list(yyvsp[-1].STRING_LIST);
		}
break;
case 207:
{ yyval.STRING_LIST = yyvsp[0].STRING_LIST; }
break;
case 208:
{
			struct string_list *d;
			yyvsp[-1].STRING_LIST->next = yyvsp[0].STRING_LIST; yyval.STRING_LIST = yyvsp[-1].STRING_LIST; 
			d = yyvsp[-1].STRING_LIST;
			while(d) {
				verb_printf("string_list:<%s>\n", d->string);
				d = d->next;
			}
		}
break;
case 209:
{
			struct string_list *d;
			yyvsp[-2].STRING_LIST->next = yyvsp[0].STRING_LIST; yyval.STRING_LIST = yyvsp[-2].STRING_LIST; 
			d = yyvsp[-2].STRING_LIST;
			while(d) {
				verb_printf("string_list:<%s>\n", d->string);
				d = d->next;
			}
		}
break;
case 210:
{
		struct string_list	*new;
			new = malloc(sizeof(*new));
			if ( !new ) yyerror();
			new->string = malloc(strlen(yyvsp[0].STRPTR)+1);
			if ( !new->string ) yyerror();
			strcpy(new->string, yyvsp[0].STRPTR);
			new->next = NULL;
			yyval.STRING_LIST = new;
			free(yyvsp[0].STRPTR);
		}
break;
case 211:
{
			struct domain_list *d=yyvsp[0].DOMAIN;
			verb_printf("<%s>\n", d->domain);
			yyval.DOMAIN = yyvsp[0].DOMAIN;
		}
break;
case 212:
{
			struct domain_list *d;
			yyvsp[-1].DOMAIN->next = yyvsp[0].DOMAIN; yyval.DOMAIN = yyvsp[-1].DOMAIN;
			d = yyvsp[-1].DOMAIN;
			while(d) {
				verb_printf("<%s>\n", d->domain);
				d = d->next;
			}
		}
break;
case 213:
{
			struct	domain_list *new;
			char		    *s, *d;

			new = malloc(sizeof(*new));
			if ( !new ) {
			    verb_printf("malloc failed\n");
			    yyerror();
			}
			new->domain = malloc(strlen(yylval.STRPTR)+1);
			if ( !new->domain ) yyerror();
			s = yylval.STRPTR;
			d = new->domain;
			while( *s ) {*d = tolower(*s);s++;d++;}; *d=0;
			if ( !strcmp(yylval.STRPTR, "*") )
				new->length = -1;
			    else
				new->length = strlen(yylval.STRPTR);
			free(yylval.STRPTR);
			new->next = NULL;
			yyval.DOMAIN = new;
			}
break;
case 215:
{
			yyvsp[-1].NETPTR->next = yyvsp[0].NETPTR; yyval.NETPTR = yyvsp[-1].NETPTR;
		}
break;
case 216:
{
			char	*n, *l, *dot, *dot_holder, *t;
			int	net = 0, masklen = 0, i = 24;
			struct	cidr_net *new;
			n = yylval.STRPTR;
			l = strchr(n, '/');
			if ( !l ) {
				yyerror();
			}
			*l = 0;
			masklen = atoi(l+1);
			t = n;
			while( ( dot=(char*)strtok_r(t, ".", &dot_holder) ) && (i >=0) ) {
				t = NULL;
				net |= (atol(dot) << i);
				i -= 8;
			}
			new =  malloc(sizeof(struct cidr_net));
			new->network = net;
			new->masklen = masklen;
			new->next = NULL;
			if ( !masklen )
				new->mask = 0;
			    else {
				if ( (masklen<0) || (masklen>32) ) {
					verb_printf("Invalid masklen %d\n", masklen);
					yyerror();
					return(-1);
				}
				new->mask = (int)0x80000000 >> ( masklen - 1 );
			    }
			verb_printf("NetWork: <<%8.8x/%d & %08x>>\n",  new->network,
							new->masklen,
							new->mask);
			free(yylval.STRPTR);
			yyval.NETPTR = new;
		}
break;
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
